unit IO;

interface

uses Crt;

procedure ShowCursor(Show: Boolean);
procedure Redraw(x, y, w, h, Attr: Integer);
procedure DrawFrame(x, y, w, h: Integer);
function InputBox(Message: String): String;
procedure MessageBox(Message: String);

implementation

procedure ShowCursor(Show: Boolean);
  var l1, l2: Byte;
begin
  if Show then begin
    l1 := 6;
    l2 := 7;
  end
  else begin
    l1 := 20;
    l2 := 0;
  end;
  asm
    mov ch, l1
    mov cl, l2
    mov ah, 1
    int 10h
  end;
end;

procedure Redraw(x, y, w, h, Attr: Integer);
  var i, j: Integer;
begin
  TextBackGround(Attr);
  TextColor(Attr);

  for i := 1 to h do begin
    GotoXY(x, y + i - 1);

    for j := 1 to w do
      Write(' ');
  end;
end;

procedure DrawFrame(x, y, w, h: Integer);
  var i: Integer;
begin
  TextBackGround(7);

  TextColor(15);
  GotoXY(x + 1, y);
  for i := 1 to w - 2 do
    Write('');

  for i := 1 to h - 2 do begin
    GotoXY(x, y + i);
    Write('');
  end;

  GotoXY(x, y);
  Write('');
  GotoXY(x, y + h - 1);
  Write('');

  TextColor(8);
  GotoXY(x + 1, y + h - 1);
  for i := 1 to w - 2 do
    Write('');

  for i := 1 to h - 2 do begin
    GotoXY(x + w - 1, y + i);
    Write('');
  end;

  GotoXY(x + w - 1, y);
  Write('');
  GotoXY(x + w - 1, y + h - 1);
  Write('');
end;

function InputBox(Message: String): String;
  var x: Integer;
      S: String;
      C: Char;
      i: Integer;
begin
  x := length(Message) + 10;
  x := 40 - x div 2;
  S := '';

  DrawFrame(x, 10, length(Message) + 10, 5);
  GotoXY(40 - (length(Message) + 2) div 2, 10);
  TextColor(0);
  Write(' ', Message, ' ');
  Redraw(x + 1, 11, length(Message) + 8, 3, 7);
  TextColor(15);
  TextBackGround(0);
  GotoXY(x + 3, 12);
  for i := 1 to length(Message) + 4 do
    Write(' ');
  ShowCursor(True);
  GotoXY(x + 4, 12);
  Write(' ');
  GotoXY(x + 4, 12);

  C := ReadKey;

  while C <> #13 do begin
    if (C > #32) and (C < #123) and (length(S) < length(Message) + 2) then begin
      Write(C);
      S := S + C;
    end;
    C := ReadKey;
  end;

  Redraw(x, 10, length(Message) + 10, 5, 0);
  ShowCursor(False);
  InputBox := S;
end;

procedure MessageBox(Message: String);
  var x: Integer;
begin
  x := length(Message) + 10;
  x := 40 - x div 2;

  DrawFrame(x, 11, length(Message) + 10, 5);
  Redraw(x + 1, 12, length(Message) + 8, 3, 7);
  GotoXY(x + 5, 13);
  TextColor(0);
  Write(Message);

  ReadKey;
  Redraw(x, 11, length(Message) + 10, 5, 0);
end;

end.
