unit Menu;

interface

uses Crt, Io;

type
    PMenuItem = ^TMenuItem;
    TMenuItem = record
      Name: String[20];
      Command: Word;
      Next: PMenuItem;
    end;

    PSubMenu = ^TSubMenu;
    TSubMenu = record
      Name: String[20];
      Item: PMenuItem;
      Next: PSubMenu;
    end;

    PMenu = ^TMenu;
    TMenu = object
      Items: PSubMenu;
      NumItems: Integer;
      NumSubItems: Integer;
      ReturnCode: Integer;
      x, y, w, h: Integer;
      constructor Init(Menu: PSubMenu);
      procedure DrawRamka(x_, y_, w_, h_: Integer);
      procedure DrawMainMenu(Selected: Integer);
      procedure DrawSubMenu(Sel1, Sel2: Integer);
      function Run: Integer;
      destructor Done;
    end;

    function NewSubMenu(Name: String; SubMenu: PMenuItem; Next: PSubMenu): PSubMenu;
    function NewMenuItem(Name: String; Command: Word; Next: PMenuItem): PMenuItem;

var n, n_, m, m_: Integer;

implementation

constructor TMenu.Init(Menu: PSubMenu);
begin
  TextBackGround(0);
  Clrscr;
  ShowCursor(False);

  Items := Menu;
  NumSubItems := 0;

  DrawRamka(1, 1, 80, 3);
  DrawMainMenu(0);
end;

procedure TMenu.DrawRamka(x_, y_, w_, h_: Integer);
begin
  x := x_;
  y := y_;
  w := w_;
  h := h_;

  DrawFrame(x, y, w, h);
end;

procedure TMenu.DrawMainMenu(Selected: Integer);
  var P: PSubMenu;
      i, j, n: Integer;
      C: Char;
begin
  P := Items;
  NumItems := 0;

  GotoXY(2, 2);
  TextColor(0);
  TextBackGround(7);

  n := -1;
  j := 0;

  for i := 1 to 78 do begin
    if n = 0 then begin
      if j = Selected then begin
        TextColor(14);
        TextBackGround(1);
      end
      else begin
        TextColor(0);
        TextBackGround(7);
      end;

      Inc(NumItems);
    end;

    if n = -1 then begin
      TextColor(0);
      TextBackGround(7);
    end;

    if n > 0 then
      C := P^.Name[n]
    else
      C := ' ';

    if P <> nil then
    if n = length(P^.Name) then begin
      n := -3;
      P := P^.Next;
      Inc(j);
    end;

    Write(C);

    if P <> nil then
      Inc(n)
    else
      if n <> -1 then Inc(n);

  end;

  NumItems := NumItems - 1;
end;

procedure TMenu.DrawSubMenu(Sel1, Sel2: Integer);
  var P: PSubMenu;
      T: PMenuItem;
      i, x_, y_, w_, h_: Integer;
begin
  x_ := 2;
  P := Items;
  NumSubItems := 0;

  for i := 1 to Sel1 do begin
    x_ := x_ + length(P^.Name) + 3;
    P := P^.Next;
  end;

  h_ := 0;
  T := P^.Item;
  w_ := length(T^.Name);

  while T <> nil do begin
    if length(T^.Name) > w_ then
      w_ := length(T^.Name);
    Inc(h_);
    Inc(NumSubItems);
    T := T^.Next;
  end;

  T := P^.Item;
  h_ := h_ + 2;
  y_ := 6;

  DrawRamka(x_, 5, w_ + 4, h_);
  TextColor(0);
  TextBackGround(7);

  while T <> nil do begin
    GotoXY(x_ + 1, y_);

    if y_ - 6 = Sel2 then begin
      TextColor(14);
      TextBackGround(1);
      ReturnCode := T^.Command;
    end
    else begin
      TextColor(0);
      TextBackGround(7);
    end;

    Write(' ');
    for i := 1 to w_ do begin
      if i < length(T^.Name) + 1 then
        Write(T^.Name[i])
      else
        Write(' ');
    end;
    Write(' ');

    Inc(y_);

    T := T^.Next;
  end;

  NumSubItems := NumSubItems - 1;
end;

function NewSubMenu(Name: String; SubMenu: PMenuItem; Next: PSubMenu): PSubMenu;
  var P: PSubMenu;
begin
  P := New(PSubMenu);
  P^.Name := Name;
  P^.Item := SubMenu;
  P^.Next := Next;
  NewSubMenu := P;
end;

function NewMenuItem(Name: String; Command: Word; Next: PMenuItem): PMenuItem;
  var P: PMenuItem;
begin
  P := New(PMenuItem);
  P^.Name := Name;
  P^.Command := Command;
  P^.Next := Next;
  NewMenuItem := P;
end;

function TMenu.Run: Integer;
  var C: Char;
begin
  DrawSubMenu(n, m);

  repeat
    C := ReadKey;

    case C of
      #77: Inc(n);
      #75: Dec(n);
      #80: Inc(m);
      #72: Dec(m);
    end;

    if n > NumItems then n := 0;
    if n < 0 then n := NumItems;
    if m > NumSubItems then m := 0;
    if m < 0 then m := NumSubItems;

    if (n <> n_) then begin
      DrawMainMenu(n);
      Redraw(x, y, w, h, 0);
      DrawSubMenu(n, 0);
      m := 0;
    end;

    if (m <> m_) then
      DrawSubMenu(n, m);

    n_ := n;
    m_ := m;
  until C = #13;
  Redraw(x, y, w, h, 0);
  Run := ReturnCode;
end;

destructor TMenu.Done;
begin
  TextBackGround(0);
  TextColor(7);
  Clrscr;
  ShowCursor(True);
end;

end.